## nvidia-cuda-toolkit 7.5.18

=== local/cuda-7.5/nvvm/libnvvm-samples/cuda-c-linking/CMakeLists.txt ===
################################################################################
#
# Copyright 1993-2014 NVIDIA Corporation.  All rights reserved.
#
# NOTICE TO USER:   
#
# This source code is subject to NVIDIA ownership rights under U.S. and 
# international Copyright laws.  
#
# NVIDIA MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOURCE 
# CODE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR 
# IMPLIED WARRANTY OF ANY KIND.  NVIDIA DISCLAIMS ALL WARRANTIES WITH 
# REGARD TO THIS SOURCE CODE, INCLUDING ALL IMPLIED WARRANTIES OF 
# MERCHANTABILITY, NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE.   
# IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL, 
# OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS 
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE 
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE 
# OR PERFORMANCE OF THIS SOURCE CODE.  
#
# U.S. Government End Users.  This source code is a "commercial item" as 
# that term is defined at 48 C.F.R. 2.101 (OCT 1995), consisting  of 
# "commercial computer software" and "commercial computer software 
# documentation" as such terms are used in 48 C.F.R. 12.212 (SEPT 1995) 
# and is provided to the U.S. Government only as a commercial end item.  
# Consistent with 48 C.F.R.12.212 and 48 C.F.R. 227.7202-1 through 
# 227.7202-4 (JUNE 1995), all U.S. Government End Users acquire the 
# source code with only those rights set forth herein.
#
################################################################################


set(LLVM_LINK_COMPONENTS Core Support)

add_llvm_executable(cuda-c-linking cuda-c-linking.cpp)

target_link_libraries(cuda-c-linking ${NVVM_LIB} ${CUDA_LIB})

if (APPLE OR UNIX)
  set_target_properties(cuda-c-linking PROPERTIES
    LINK_FLAGS "-Wl,-rpath,${LIBNVVM_RPATH}")
endif()


##############################
### Math Lib
##############################

### The math library is built as a collection of several variants.  We compile
### one version each for {compute_20, compute_30, compute_35} X {32-bit/64-bit}.
### The results are bundled into a system library using the 'nvcc -lib' feature.

set(mathlib_sources math-funcs.cu)

#>> nvcc -m32 -gencode=compute_20,code=sm_20 ... -dc math-funcs.cu -o math-funcs32.o
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/math-funcs32.o"
                   COMMAND ${NVCC} -m32 -gencode arch=compute_20,code=sm_20 -gencode arch=compute_30,code=sm_30 -gencode arch=compute_35,code=sm_35 -gencode arch=compute_50,code=sm_50 -dc "${CMAKE_CURRENT_SOURCE_DIR}/math-funcs.cu" -o "${CMAKE_CURRENT_BINARY_DIR}/math-funcs32.o"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/math-funcs.cu"
                   COMMENT "Building math-funcs32.o")

#>> nvcc -m32 -lib math-funcs32.o -o libmathfuncs32.a
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/libmathfuncs32.a"
                   COMMAND ${NVCC} -m32 -lib "${CMAKE_CURRENT_BINARY_DIR}/math-funcs32.o" -o "${CMAKE_CURRENT_BINARY_DIR}/libmathfuncs32.a"
                   DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/math-funcs32.o"
                   COMMENT "Building libmathfuncs32.a")

#>> nvcc -m64 -gencode=compute_20,code=sm_20 ... -dc math-funcs.cu -o math-funcs64.o
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/math-funcs64.o"
                   COMMAND ${NVCC} -m64 -gencode arch=compute_20,code=sm_20 -gencode arch=compute_30,code=sm_30 -gencode arch=compute_35,code=sm_35 -gencode arch=compute_50,code=sm_50 -dc "${CMAKE_CURRENT_SOURCE_DIR}/math-funcs.cu" -o "${CMAKE_CURRENT_BINARY_DIR}/math-funcs64.o"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/math-funcs.cu"
                   COMMENT "Building math-funcs64.o")

#>> nvcc -m64 -lib math-funcs64.o -o libmathfuncs64.a
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/libmathfuncs64.a"
                   COMMAND ${NVCC} -m64 -lib "${CMAKE_CURRENT_BINARY_DIR}/math-funcs64.o" -o "${CMAKE_CURRENT_BINARY_DIR}/libmathfuncs64.a"
                   DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/math-funcs64.o"
                   COMMENT "Building libmathfuncs64.a")

add_custom_target(mathlib DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/libmathfuncs32.a" "${CMAKE_CURRENT_BINARY_DIR}/libmathfuncs64.a")

add_dependencies(cuda-c-linking mathlib)

install(TARGETS cuda-c-linking DESTINATION bin)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libmathfuncs32.a"
              "${CMAKE_CURRENT_BINARY_DIR}/libmathfuncs64.a" DESTINATION bin)

=== local/cuda-7.5/extras/CUPTI/sample/callback_event/Makefile ===
#
# Copyright 2011-2015 NVIDIA Corporation. All rights reserved
# 
INCLUDES=-I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):../../libWin32:../../libx64
    LIBS= -lcuda -L ../../libWin32 -L ../../libx64 -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):../../lib
        LIBS= -Xlinker -framework -Xlinker cuda -L ../../lib -lcupti
    else
        export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib:../../lib64
        LIBS= -lcuda -L ../../lib -L ../../lib64 -lcupti
    endif
    OBJ = o
endif

callback_event: callback_event.$(OBJ)
	nvcc -o $@ callback_event.$(OBJ) $(LIBS)

callback_event.$(OBJ): callback_event.cu
	nvcc -c $(INCLUDES) $<

run: callback_event
	./$<

clean:
	rm -f callback_event callback_event.$(OBJ)

=== local/cuda-7.5/extras/CUPTI/sample/cupti_query/Makefile ===
#
# Copyright 2011-2015 NVIDIA Corporation. All rights reserved
# 
INCLUDES=-I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):../../libWin32:../../libx64
    LIBS= -lcuda -L ../../libWin32 -L ../../libx64 -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):../../lib
        LIBS= -Xlinker -framework -Xlinker cuda -L ../../lib -lcupti
    else
        export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib:../../lib64
        LIBS= -lcuda -L ../../lib -L ../../lib64 -lcupti
    endif
    OBJ = o
endif

cupti_query: cupti_query.$(OBJ)
	nvcc -o $@ cupti_query.$(OBJ) $(LIBS)

cupti_query.$(OBJ): cupti_query.cpp
	nvcc -c $(INCLUDES) $<

run: cupti_query
	./$<

clean:
	rm -f cupti_query cupti_query.$(OBJ)

=== local/cuda-7.5/extras/CUPTI/sample/sass_source_map/Makefile ===
#
# Copyright 2014-2015 NVIDIA Corporation. All rights reserved
# 
INCLUDES=-I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):../../libWin32:../../libx64
    LIBS= -lcuda -L ../../libWin32 -L ../../libx64 -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):../../lib
        LIBS= -Xlinker -framework -Xlinker cuda -L ../../lib -lcupti
    else
        export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib:../../lib64
        LIBS= -lcuda -L ../../lib -L ../../lib64 -lcupti
    endif
    OBJ = o
endif

sass_source_map: sass_source_map.$(OBJ)
	nvcc -o $@ sass_source_map.$(OBJ) $(LIBS)

sass_source_map.$(OBJ): sass_source_map.cu
	nvcc -arch=sm_20 -lineinfo  -c $(INCLUDES) $<

run: sass_source_map
	./$<

clean:
	rm -f sass_source_map sass_source_map.$(OBJ)

=== debian/changelog ===
nvidia-cuda-toolkit (7.5.18-0ubuntu1) xenial; urgency=medium

  [ Zhou Mo ]
  * New upstream release 7.5 (Sept 2015).  (Closes: #807579)
  * SOVERSION bump: 7.0 => 7.5, rename all library packages.
  * Update symbols control files. 
  * [ppc64el] Adjust location of nvvm/lib.
  * Update Lintian overrides.

  [ Andreas Beckmann ]
  * Refresh man-sections.patch.
  * debian/copyright: Synchronize with updated EULA.txt.
  * Use multiarch substitution in nvcc.profile.
  * gcc-support.patch: New, allow usage of GCC 5.
  * Use gcc-5/g++-5 as preferred compiler.
  * Update documentation regarding the CUDA Code Samples.
  * [ppc64el] Use the no-libcuda1 virtual package on Ubuntu.
  * Upload to experimental.

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 30 Mar 2016 12:54:00 +0200

nvidia-cuda-toolkit (7.0.28-4) unstable; urgency=medium

  * [ppc64el] Enable the nvidia-opencl-dev package.
  * Ship nvprune manpage.
  * rules: Enforce that arch:all documentation packages are built on amd64 only.
  * get-orig-source: Exclude driver and GPU Deployment Kit.
  * Drop Conflicts/Breaks/Replaces targeting pre-jessie versions.
  * Add Conflicts with the CUDA repo packages from NVIDIA for Ubuntu.
  * man-typos.patch: Fix more misspellings.
  * Bump Standards-Version to 3.9.7 (no changes needed).
  * Update Lintian overrides.  (Closes: #815822)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 28 Feb 2016 14:02:08 +0100

nvidia-cuda-toolkit (7.0.28-3) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Drop Build-Depends on libcuda1 and always use the libcuda.so stub (with
    some postprocessing) for dependency resolution.
  * Revert the no-libcuda1 virtual package hack.

  [ Graham Inggs ]
  * [ppc64el] Add Build-Depends on libexpat1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Feb 2016 08:33:34 +0100

nvidia-cuda-toolkit (7.0.28-2) unstable; urgency=medium

  * Merge changes from 6.5.19-3.
  * get-orig-source: Generate an additional .orig-ppc64el tarball by repacking
    cuda-repo-ubuntuAABB-X-Y-local_*_ppc64el.deb.
  * Add preliminary support for building ppc64el packages.
  * Work around libcuda1 not being available on ppc64el:
    - Use the stub library shipped with the library for dependency resolution.
    - libcudart7.0:ppc64el: Provide virtual package no-libcuda1 and use that
      as alternative dependency.
  * [ppc64el] Strip RPATH from cuda-gdb.
  * Apply the patches over the nvidia-cuda symlink.
  * Update Lintian overrides.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 03 Feb 2016 09:43:31 +0100

nvidia-cuda-toolkit (7.0.28-1) experimental; urgency=medium

  [ Zhou Mo ]
  * New upstream release 7.0 (March 2015).  (Closes: #783770)
  * Drop i386 support for all remaining packages, removed upstream.
  * SOVERSION bump: 6.5 => 7.0, rename all library packages and
    bump alternate virtual B-D to libcuda-7.0-1.
  * libnvvm SOVERSION bump: 2 => 3, rename libnvvm2 to libnvvm3.
  * Update symbols control files.
  * Do not ship open64 binaries, no longer provided upstream.
    (Closes: #774297)
  * Ship new headers and nvprune binary.
  * libcusolver7.0: New package for the cuSOLVER library.
  * libnvrtc7.0: New package for the NVRTC library.

  [ Andreas Beckmann ]
  * Refresh man-sections.patch and man-typos.patch.
  * debian/copyright: Synchronize with updated EULA.txt.
  * nvidia-cuda-dev: Ship the library stubs, downgrade Depends: libcuda1 to
    Recommends.
  * Remove compatibility symlink for thrust includes.
  * Update documentation regarding the CUDA Code Samples.
  * nvidia-visual-profiler, nvidia-nsight: Disable more tracking scripts.
  * Update Lintian overrides.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 28 Nov 2015 07:35:39 +0100

nvidia-cuda-toolkit (6.5.19-3) unstable; urgency=medium

  * Do not run dh_strip_nondeterminism, it may perform modifications not
    permitted by the NVIDIA license.
  * get-orig-source: Generate tarball reproducibly.
  * Add Zhou Mo to Uploaders.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 20 Jan 2016 03:11:45 +0100

nvidia-cuda-toolkit (6.5.19-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 13 Nov 2015 19:46:02 +0100

nvidia-cuda-toolkit (6.5.19-1) experimental; urgency=medium

  * New upstream release 6.5 (September 2014).
    - Adding support for GTX9xx GPUs. (Needs a 343.xx or newer driver.)
  * Refresh man-sections.patch.
  * Update symbols control files.
  * Update Lintian overrides.
  * nvidia-cuda-toolkit: Suggest nvidia-driver and mention in the long
    description that an NVIDIA GPU and the NVIDIA driver kernel module are
    required to run CUDA applications.  (Closes: #795262)
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 05 Oct 2015 23:26:43 +0200

=== debian/control ===
Source: nvidia-cuda-toolkit
Section: non-free/libs
Priority: extra
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
 Russ Allbery <rra@debian.org>,
 Graham Inggs <ginggs@debian.org>,
 Zhou Mo <cdluminate@gmail.com>,
Build-Depends:
 debhelper (>= 9),
 quilt,
 libncurses5,
 chrpath [ppc64el],
 libexpat1 [ppc64el],
Standards-Version: 3.9.7
Homepage: http://www.nvidia.com/CUDA
Vcs-Svn: svn://anonscm.debian.org/pkg-nvidia/packages/nvidia-cuda-toolkit/trunk
Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-nvidia/packages/nvidia-cuda-toolkit/
XS-Autobuild: yes

Package: nvidia-cuda-toolkit
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 nvidia-profiler (= ${binary:Version}),
 nvidia-cuda-dev (= ${binary:Version}),
 nvidia-opencl-dev (= ${binary:Version}) | opencl-dev,
 gcc-5 | gcc-4.9 | gcc-4.8,
 g++-5 | g++-4.9 | g++-4.8,
 ${shlibs:Depends}, ${misc:Depends},
Recommends:
 nvidia-cuda-doc (= ${source:Version}),
 nvidia-cuda-gdb (= ${binary:Version}),
 nvidia-visual-profiler (= ${binary:Version}),
Suggests:
 libcupti-dev,
 nvidia-driver (>= ${nvidia:MinVersion}) [!ppc64el],
Conflicts:
# packages from the repository packages provided by NVIDIA
 cuda-repo-ubuntu1204,
 cuda-repo-ubuntu1404,
 cuda-repo-ubuntu1404-7-5-local,
 cuda-repo-ubuntu1410,
 cuda-repo-ubuntu1504,
 cuda-repo-ubuntu1504-7-5-local,
 cuda-license-7-5,
Description: NVIDIA CUDA development toolkit
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the nvcc compiler and other tools needed for building
 CUDA applications.
 .
 Running CUDA applications requires a supported NVIDIA GPU and the NVIDIA
 driver kernel module.

Package: nvidia-cuda-doc
Section: non-free/doc
Architecture: all
Depends: ${misc:Depends}
Description: NVIDIA CUDA and OpenCL documentation
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the developer documentation.

Package: nvidia-cuda-gdb
Section: non-free/devel
Architecture: amd64 ppc64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version})
Description: NVIDIA CUDA Debugger (GDB)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the cuda-gdb debugger.

Package: nvidia-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 libcuinj64-${cuda:SoVersion},
 ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA Profiler for CUDA and OpenCL
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the nvprof profiler.

Package: nvidia-visual-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 default-jre | java6-runtime,
 libgtk2.0-0,
 nvidia-profiler (= ${binary:Version}),
 ${perl:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version}),
Homepage: http://developer.nvidia.com/nvidia-visual-profiler
Description: NVIDIA Visual Profiler for CUDA and OpenCL
 The NVIDIA Visual Profiler is a cross-platform performance profiling tool
 that delivers developers vital feedback for optimizing CUDA C/C++ and OpenCL
 applications.

Package: nvidia-nsight
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 default-jre | java6-runtime,
 libgtk2.0-0,
 ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version}),
Homepage: http://developer.nvidia.com/cuda/nsight-eclipse-edition
Description: NVIDIA Nsight Eclipse Edition
 NVIDIA Nsight Eclipse Edition is a full-featured IDE powered by the Eclipse
 platform that provides an all-in-one integrated environment to edit, build,
 debug and profile CUDA-C applications.
 Nsight Eclipse Edition supports a rich set of commercial and free plugins.

Package: nvidia-cuda-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el
Depends:
 libcudart${cuda:SoVersion} (= ${binary:Version}),
 libcublas${cuda:SoVersion} (= ${binary:Version}),
 libnvblas${cuda:SoVersion} (= ${binary:Version}),
 libcufft${cuda:SoVersion} (= ${binary:Version}),
 libcufftw${cuda:SoVersion} (= ${binary:Version}),
 libcusparse${cuda:SoVersion} (= ${binary:Version}),
 libcurand${cuda:SoVersion} (= ${binary:Version}),
 libcusolver${cuda:SoVersion} (= ${binary:Version}),
 libnppc${cuda:SoVersion} (= ${binary:Version}),
 libnppi${cuda:SoVersion} (= ${binary:Version}),
 libnpps${cuda:SoVersion} (= ${binary:Version}),
 libnvrtc${cuda:SoVersion} (= ${binary:Version}),
 libcuinj64-${cuda:SoVersion} (= ${binary:Version}),
 libnvtoolsext1 (= ${binary:Version}),
 libnvvm3 (= ${binary:Version}),
 libthrust-dev,
 ${misc:Depends}
Recommends:
 ${package:libcuda1},
 libgl1-mesa-dev | libgl-dev,
 libvdpau-dev,
 libnvcuvid1,
Breaks:
 libcuda1 (<< ${nvidia:MinVersion}),
 libcuinj64-5.5 (<< 5.5.22-6~),
 libcuinj64-6.0 (<< 6.0.37-2~),
Replaces:
 libcuinj64-5.5 (<< 5.5.22-6~),
 libcuinj64-6.0 (<< 6.0.37-2~),
Description: NVIDIA CUDA development files
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the development files: headers and libraries.

Package: nvidia-opencl-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el
Multi-Arch: same
Depends:
 ${package:nvidia-libopencl1},
 opencl-headers (>= 1.2),
 ${misc:Depends}
Recommends:
 libgl1-mesa-dev | libgl-dev,
 nvidia-opencl-icd,
Provides:
 opencl-dev,
Conflicts:
 opencl-dev,
Replaces:
 opencl-dev,
Description: NVIDIA OpenCL development files
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This metapackage provides the development files: headers and libraries.

Package: libcudart7.5
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends:
 ${package:libcuda1}
Provides:
 no-libcuda1 [ppc64el],
Description: NVIDIA CUDA Runtime Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the CUDA Runtime API library for high-level CUDA
 programming, on top of the CUDA Driver API.

Package: libcublas7.5
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA cuBLAS Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 The cuBLAS library is an implementation of BLAS (Basic Linear Algebra
 Subprograms) on top of the NVIDIA CUDA runtime. It allows the user to access
 the computational resources of NVIDIA Graphics Processing Unit (GPU), but
 does not auto-parallelize across multiple GPUs.
 .
 This package contains the cuBLAS runtime library.

Package: libnvblas7.5
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVBLAS runtime library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 The NVBLAS Library is a GPU-accelerated Library that implements BLAS (Basic
 Linear Algebra Subprograms). It can accelerate most BLAS Level-3 routines by
 dynamically routing BLAS calls to one or more NVIDIA GPUs present in the
 system, when the characteristics of the call make it to speedup on a GPU.

Package: libcufft7.5
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA cuFFT Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 The FFT is a divide-and-conquer algorithm for efficiently computing discrete
 Fourier transforms of complex or real-valued data sets. It is one of the most
 important and widely used numerical algorithms in computational physics and
 general signal processing. The cuFFT library provides a simple interface for
 computing FFTs on an NVIDIA GPU, which allows users to quickly leverage the
 floating-point power and parallelism of the GPU in a highly optimized and
 tested FFT library.
 .
 This package contains the cuFFT runtime library.

Package: libcufftw7.5
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA cuFFTW Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 The FFT is a divide-and-conquer algorithm for efficiently computing discrete
 Fourier transforms of complex or real-valued data sets. It is one of the most
 important and widely used numerical algorithms in computational physics and
 general signal processing. The cuFFT library provides a simple interface for
 computing FFTs on an NVIDIA GPU, which allows users to quickly leverage the
 floating-point power and parallelism of the GPU in a highly optimized and
 tested FFT library.
 .
 This package contains the cuFFTW runtime library.

Package: libcusparse7.5
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA cuSPARSE Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 The cuSPARSE library contains a set of basic linear algebra subroutines used
 for handling sparse matrices. It is implemented on top of the NVIDIA CUDA
 runtime and is designed to be called from C and C++. The library routines can
 be classified into four categories:
  * Level 1: operations between a vector in sparse format and a vector in dense
 format
  * Level 2: operations between a matrix in sparse format and a vector in dense
 format
  * Level 3: operations between a matrix in sparse format and a set of vectors
 in dense format
  * Conversion: operations that allow conversion between different matrix
 formats
 .
 This package contains the cuSPARSE runtime library.

Package: libcurand7.5
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA cuRAND Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 The cuRAND library provides facilities that focus on the simple and efficient
 generation of high-quality pseudorandom and quasirandom numbers.
 A pseudorandom sequence of numbers satisfies most of the statistical
 properties of a truly random sequence but is generated by a deterministic
 algorithm. A quasirandom sequence of n-dimensional points is generated by a

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH		?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH	?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
VENDOR			:= $(shell dpkg-vendor --derives-from Ubuntu && echo Ubuntu || echo Debian)

include debian/rules.defs
CUDA_VERSION_TOOLKIT	:= $(shell dpkg-parsechangelog | sed -nr '/^Version:/s/Version: (.*:)?(.*)-(.*)/\2/p')
CUDA_VERSION_MAJOR	?= $(word 1,$(subst ., ,$(CUDA_VERSION_TOOLKIT)))
CUDA_VERSION_MINOR	?= $(word 2,$(subst ., ,$(CUDA_VERSION_TOOLKIT)))
version_driver		 = $(CUDA_VERSION_DRIVER)
version_driver_major	 = $(word 1,$(subst ., ,$(version_driver)))
watch_url		 = $(if $(CUDA_BETA),$(CUDA_WATCH_URL_BETA),$(CUDA_WATCH_URL))

package_libcuda1 \
	= libcuda1 (>= $${nvidia:MinVersion}) \
	| libcuda-$${cuda:SoVersion}-1
ifeq ($(VENDOR),Ubuntu)
package_libcuda1	+= | no-libcuda1 [ppc64el]
endif
        
package_nvidia-libopencl1 \
	= nvidia-libopencl1 (>= $${nvidia:MinVersion}) \
	| libopencl-1.2-1

# system libdir
libdir			 = usr/lib/$(DEB_HOST_MULTIARCH)

TEMPLATES	:= $(wildcard debian/*.in)
SOVERTEMPLATES	:= $(wildcard debian/*SOVER*)
AUTOGEN         += $(patsubst %.in,%,$(TEMPLATES))
AUTOGEN		+= $(subst SOVER,$(CUDA_SOVERSION),$(sort $(patsubst %.in,%,$(SOVERTEMPLATES))))
AUTOKEEP	 = debian/watch
AUTOCLEAN	 = $(filter-out $(AUTOKEEP),$(AUTOGEN))
AUTOCLEAN	+= debian/shlibs.local


.PHONY: autogen prepare
autogen: $(AUTOGEN)
prepare: autogen unpack-stamp compare-copyright-license


nvidia-cuda-amd64: debian/rules debian/rules.shuffle
	dh_testdir
	$(RM) -r $@ $@.tmp
	sh $(CUDA_FILENAME.amd64) --noexec --keep --target $@.tmp
	$(MAKE) -C $@.tmp -f ../debian/rules.shuffle shuffle-nvidia-cuda-amd64
	mv $@.tmp $@

nvidia-cuda-ppc64el: debian/rules debian/rules.shuffle
	dh_testdir
	$(RM) -r $@ $@.tmp
	mkdir $@.tmp
	@set -e -x ; for deb in ppc64el/cuda*.deb ; do dpkg -x $$deb $@.tmp/ubuntutree ; done
	$(MAKE) -C $@.tmp -f ../debian/rules.shuffle shuffle-nvidia-cuda-ppc64el
	mv $@.tmp $@

unpack-stamp: nvidia-cuda-$(DEB_HOST_ARCH)
	ln -s nvidia-cuda-$(DEB_HOST_ARCH) nvidia-cuda
	QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	touch $@

# Reformat the EULA to the format needed for debian/copyright.
nvidia-cuda/EULA.txt: unpack-stamp
EULA.fmt: nvidia-cuda/EULA.txt
	cat $<  | fromdos | fromdos | expand \
		| iconv -f CP1255 -t latin1//TRANSLIT \
		| fold -s -w 80 \
		| sed -e 's/ *$$//;s/^$$/./;s/^/ /;' \
		> $@

# Compare the license in debian/copyright with the EULA shipped in the archive.
compare-copyright-license: EULA.fmt
	sed -e '1,/^License: other-NVIDIA-CUDA-TOOLKIT/d; /^$$/,$$d; /^ .$$/d' debian/copyright > copyright.tmp
	sed -e '/^ .$$/d' EULA.fmt > EULA.tmp
	diff -w copyright.tmp EULA.tmp
	rm -f copyright.tmp EULA.tmp


.PHONY: binary binary-arch binary-indep build clean install
binary binary-arch build clean install:
	dh $@

binary-indep:
	# the documentation packages must be built on amd64 (otherwise some parts are missing)
	test "$(DEB_HOST_ARCH)" = "amd64"
	dh $@

override_dh_auto_configure: $(AUTOGEN) unpack-stamp

override_dh_auto_install:
	mkdir debian/tmp
	cp -al nvidia-cuda-$(DEB_HOST_ARCH) debian/tmp/usr
	chmod -x debian/tmp/usr/libnvvp/*.xpm
	chmod -x debian/tmp/usr/libnsight/*.xpm
	sed -i '/^-vm$$/ d; /^..\/jre\/bin\/java$$/ d' debian/tmp/usr/libnvvp/nvvp.ini debian/tmp/usr/libnsight/nsight.ini
	chmod -x debian/tmp/usr/bin/crt/link.stub
	chmod -x debian/tmp/usr/bin/crt/prelink.stub
	chmod -x debian/tmp/usr/nvvm/include/*.h
	chmod -x debian/tmp/usr/nvvm/libnvvm-samples/build.bat
ifeq ($(DEB_HOST_ARCH),ppc64el)
	chrpath -d debian/tmp/usr/bin/cuda-gdb
endif
	# remove tracking scripts
	rm -rfv debian/tmp/usr/doc/html/common/scripts
	# remove tracking images
	find debian/tmp/usr/doc/html -name '*.html' -exec sed -r -i \
		-e '\,http://omniture.nvidia.com/b/ss/nvidiacudadocs/1/H.17--NS/0, { s,(<noscript>),<!-- \1,; s,img src,img DISABLED,; s,(</noscript>),\1 -->, }' \
		-e 's,(<script type="text/javascript" )src(="http://w.sharethis.com/button/buttons.js"[^>]*></script>),<!-- \1DISABLED\2 -->,' \
		{} +
	find debian/tmp/usr/libnsight debian/tmp/usr/libnvvp -name 'license.html' -exec sed -r -i \
		-e 's,(<script type="text/javascript" )src(="http://w.sharethis.com/button/buttons.js"[^>]*></script>),<!-- \1DISABLED\2 -->,' \
		{} +
	# reduce 'dh_install --list-missing' noise
	rm -rf debian/tmp/usr/include/thrust
	rm -rf debian/tmp/usr/lib32
	rm -rf debian/tmp/usr/*/lib32

override_dh_install:
	dh_install --list-missing
	rm -rf debian/nvidia-visual-profiler/usr/share/nvidia-visual-profiler/plugins/org.eclipse.equinox.launcher.gtk.linux.*
	rm -rf debian/nvidia-nsight/usr/share/nvidia-nsight/plugins/org.eclipse.equinox.launcher.gtk.linux.*

override_dh_installman:
	dh_installman --language=C

override_dh_makeshlibs:
	dh_makeshlibs -X/stubs/

override_dh_shlibdeps:
	mkdir libcuda
	ln -s ../nvidia-cuda/lib/stubs/libcuda.so libcuda/libcuda.so.1
	echo 'libcuda 1 XXXlibcuda1XXX' > debian/shlibs.local
	dh_shlibdeps -X/stubs/ -- -llibcuda
	$(RM) -r libcuda debian/shlibs.local
	sed -i -r 's/XXXlibcuda1XXX/$${package:libcuda1}/g' debian/*.substvars

# running dh_strip is not permitted by the NVIDIA license
override_dh_strip:
override_dh_strip_nondeterminism:

override_dh_compress:
	dh_compress -Xusr/share/doc/nvidia-cuda-doc/examples

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'package:libcuda1=$(package_libcuda1)' \
		-V'package:nvidia-libopencl1=$(package_nvidia-libopencl1)' \
		-V'cuda:SoVersion=$(CUDA_SOVERSION)' \
		-V'nvidia:MinVersion=$(version_driver)'

override_dh_auto_clean:
	$(RM) -r .pc
	$(RM) nvidia-cuda
	$(RM) -r nvidia-cuda-amd64
	$(RM) -r nvidia-cuda-ppc64el
	$(RM) EULA.fmt EULA.tmp copyright.tmp

override_dh_clean:
	dh_clean
	$(RM) $(AUTOCLEAN)
	$(MAKE) -f debian/rules $(AUTOKEEP)


# Generating control files
%:: %.in debian/rules debian/rules.defs
	perl -p \
	-e 's{#VERSION_TOOLKIT#}{$(CUDA_VERSION_TOOLKIT)}g;' \
	-e 's{#SOVERSION#}{$(CUDA_SOVERSION)}g;' \
	-e 's{#CUDA_DOWNLOAD_URL#}{$(watch_url)}g;' \
	-e 's{#LIBDIR#}{$(libdir)}g;' \
	< $< > $@

lib%$(CUDA_SOVERSION).install:: lib%SOVER.install
	cp $< $@

lib%$(CUDA_SOVERSION).links:: lib%SOVER.links
	cp $< $@

lib%$(CUDA_SOVERSION).lintian-overrides:: lib%SOVER.lintian-overrides
	cp $< $@

lib%$(CUDA_SOVERSION).symbols:: lib%SOVER.symbols
	cp $< $@

############################################################################

CACHE			?= ../.cache
ORIGDIR			?= nvidia-cuda-toolkit-$(CUDA_VERSION_TOOLKIT).orig
TARBALL_BASE		?= nvidia-cuda-toolkit_$(CUDA_VERSION_TOOLKIT).orig
TARBALL_SUFFIX		?= .tar.xz
TARBALL			?= $(TARBALL_BASE)$(TARBALL_SUFFIX)
ORIGDIR.amd64		?= $(ORIGDIR)
TARBALL.amd64		?= $(TARBALL)
ORIGDIR.ppc64el		?= $(ORIGDIR)-ppc64el
TARBALL.ppc64el		?= $(TARBALL_BASE)-ppc64el$(TARBALL_SUFFIX)

CUDA_DL_FILENAME.amd64	?= cuda_$(CUDA_VERSION_TOOLKIT)_linux.run
CUDA_DL_FILENAME.ppc64el?= ???

get-orig-source-prepare:
	$(RM) $(TARBALL)
	$(RM) $(TARBALL.amd64)
	$(RM) $(TARBALL.ppc64el)
	$(RM) -r get-orig-source || true
	mkdir get-orig-source

get-orig-source-download-%: get-orig-source-prepare
	ln -v $(CACHE)/$(CUDA_DL_FILENAME.$*) get-orig-source/ 2>/dev/null || \
		wget $(CUDA_DL_URL_BASE)/$(CUDA_DL_FILENAME.$*) -P get-orig-source/
	if [ -d $(CACHE) ] && [ ! -f $(CACHE)/$(CUDA_DL_FILENAME.$*) ]; then \
		ln -v get-orig-source/$(CUDA_DL_FILENAME.$*) $(CACHE) ; fi

# unpack the all-in-one .run cuda installer containing toolkit, driver and samples
get-orig-source-run-unpack-%: get-orig-source-download-%
	@set -e -x ; \
	    cd get-orig-source ; \
	    mkdir $(ORIGDIR.$*) ; \
	    sh $(CUDA_DL_FILENAME.$*) --noexec --keep --target tmp ; \
	    find tmp -ls ; \
	    if [ -d tmp/run_files ]; then \
	        mv -f tmp/run_files/cuda-linux*-rel*.run tmp/run_files/EULA.txt $(ORIGDIR.$*)/ ; \
	    else \
	        mv "$(CUDA_DL_FILENAME.$*)" $(ORIGDIR.$*)/ ; \
	    fi ; \
	    rm -rf tmp ; \

=== debian/watch ===
version=3
https://developer.nvidia.com/cuda-downloads .*/cuda_([0-9.]*)_linux.run
https://developer.nvidia.com/cuda-downloads .*/cuda_(.*)_linux_32.run
https://developer.nvidia.com/cuda-downloads .*/cuda_(.*)_linux_64.run
https://developer.nvidia.com/cuda-downloads .*/cuda_(.*)_linux_aarch64_native.run

# source code for nvopencc and cuda-gdb is available here:
# ftp://download.nvidia.com/CUDAOpen64/
